



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>POJ 1062  昂贵的聘礼（Dijkstra）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">POJ 1062  昂贵的聘礼（Dijkstra）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 20:21:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题意 ： 真真是做POJ第一次遇到中文题，好吧，虽然语言通了，我一开始也没看懂样例什么意思，题意的话就是说这个探险家想娶酋长的女儿，但是没有钱，酋长说他可以用祭司的水晶球或者皮袄来换取少花一部分钱，同样的祭司也提出了类似的要求。最后输出能够花的最少的钱去迎娶酋长的女儿。</p>
<p>这个题需要注意的点是：1.等级问题，等级相差过大的话，不与探险家交换；</p>
<p>2.而每一个物件，编号自1到n是已经默认的，所以不用再去赋值或者迷惑了。。</p>
<p>思路 ：就是一个最短路的问题，Dijkstra还有 Bellman ford 以及spfa都可以去求，不过倒是不知道为什么，大神们统一用的Dijkstra去做的，以致我一度认为这个题必须用这个做，后来问了秦老师，说是哪个都可以，本题是用的Dijkstra方法做的。其实就是把这个转化为一个图，建图就行了，不过应该注意的点是，每一个结点也是有值的，做的时候要别忘了加上再进行比较。</p>
<div>
<div>
<pre class="prettyprint linenums"> #include&lt;cstdio&gt;<br />
 #include&lt;cmath&gt;<br />
 #include&lt;algorithm&gt;<br />
 #include&lt;cstring&gt;<br />
 const int maxn = ;<br />
 using namespace std;<br />
 const int oo =&lt;&lt;;<br />
 int map[maxn][maxn];//map数组里存的是整个图中每两个点之间那条边的权值<br />
 int dis[maxn];//dis数组里存的是每次更新的最小值<br />
 int vis[maxn];//标记数组，表示某个点是否已被访问<br />
 int m,n;//地位等级差距限制以及物品总数<br />
 int pric[maxn],l[maxn],coun;//每个物品的价值，物品主人的等级，这个物品的替代品数<br />
 int num,repl;//替代品的编号，优惠后的价格<br />
 int max1=oo;//初始化<br />
 int i,j,k,h;

 /*Dijkstra Algorithm*/<br />
 void dijkstra(int s)<br />
 {<br />
     memset(vis,,sizeof(vis));<br />
     for(k =  ; k &lt;= n ; k++)<br />
         dis[k] = oo;//初始化<br />
     dis[] = ;<br />
     for(k =  ; k &lt;= n ; k++)<br />
     {<br />
         int u,min = oo ;<br />
         for(j =  ; j &lt;= n ; j++)<br />
         {<br />
             if(!vis[j] &amp;&amp; dis[j]&lt;=min &amp;&amp; l[j]&lt;=s+m &amp;&amp; l[j]&gt;=s)//该点没被访问过，并且小于min，物品主人没有超出等级的限制<br />
             {<br />
                 min = dis[j]; //双重循环在找每个dis的最小值<br />
                 u = j;//记下这个点的下标以用于下边dis数组的更新<br />
             }<br />
         }<br />
         vis[u] =  ;//标记结点已被访问<br />
         // if(min == oo)<br />
         //  break;<br />
         for(j =  ; j &lt;= n ; j++)<br />
         {<br />
             if(l[j]&gt;=s &amp;&amp; l[j]&lt;=s+m &amp;&amp; map[u][j]!=oo &amp;&amp; dis[j]&gt;=dis[u]+map[u][j])<br />
             //没有超出等级限制，并且这两点是有边的，还满足比他小<br />
             {<br />
                 dis[j] = dis[u]+map[u][j] ;//dis数组的更新<br />
             }<br />
         }<br />
     }<br />
     int c = pric[];<br />
     for(j =  ; j &lt;= n ; j++)<br />
     {<br />
         //因为每个节点本身是有值的，如果更新到某个结点再加上这个点物品的价值比原来那个点的钱还多，那就没有要换的必要了<br />
         if(dis[j]==oo)<br />
             continue;<br />
         if(dis[j]+pric[j] &lt; c)<br />
             c = dis[j]+pric[j];<br />
     }<br />
     max1 = min(c,max1);<br />
 }<br />
 void init()<br />
 {<br />
     for(i =  ; i &lt;= n; i++)<br />
         for(j =  ; j &lt;= n ; j++)<br />
             map[i][j]=map[j][i]=oo;<br />
 }<br />
 int main()<br />
 {<br />
     while(~scanf("%d%d",&amp;m,&amp;n))<br />
     {<br />
         init();<br />
         for(i =  ; i &lt;= n ; i++)<br />
         {<br />
             scanf("%d %d %d",&amp;pric[i],&amp;l[i],&amp;coun);<br />
             for(j =  ; j &lt;= coun ; j++)<br />
             {<br />
                 scanf("%d %d",&amp;num,&amp;repl);<br />
                 if(map[i][num]&gt;repl)<br />
                     map[i][num]=repl;<br />
             }<br />
         }<br />
         int s;<br />
         int s=max(l[]-m,);//筛选掉等级差别过大的那些等级<br />
         /*if(l[1]-m &gt; 0)<br />
             s = l[1]-m;<br />
         else s = 0;*/<br />
         for(i=s; i&lt;=l[]; i++)//每个点遍历一遍<br />
             dijkstra(i);<br />
         printf("%d\n",max1);<br />
     }<br />
     return ;<br />
 }</pre>
</div></div>
<p>Dijkstra算法的话还算是比较好理解的，其基本步骤就是：</p>
<p>1、把所有结点分成两组：<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;第一组：包括已经确定最短路径的结点；<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;第二组：包括尚未确定最短路径的结点。<br />2、开始时，第一组只包含起点，第二组包含剩余的点；<br />3、用贪心的策略，按最短路径长度递增的顺序把第二组的结点加到第一组去，直到v0可达的所有结点都包含于第一组中。在这个过程中，不断更新最短路径，总保持从v0到第一组各结点的最短路径长度dist都不大于从v0到第二组任何结点的路径长度。<br />4、每个结点对应一个距离值，第一组结点对应的距离就是v0到此结点的最短路径长度，第二组结点对应的距离值就是v0由第一组结点到此结点的最短路径长度。<br />5、直到所有的顶点都扫描完毕（v0可达的所有结点都包含于第一组中），找到v0到其它各点的所有最短路径。</p>
<p>详细可以参考大神的博客<a href="http://www.cnblogs.com/mycapple/archive/2012/08/12/2634227.html" rel="external nofollow noreferrer">http://www.cnblogs.com/mycapple/archive/2012/08/12/2634227.html</a>，有图有字生动形象</p>
<p>这个是算法邻接表的模板，秦老师写的：</p>
<div>
<div>
<pre class="prettyprint linenums"> #include &lt;stdio.h&gt;<br />
 #include &lt;string.h&gt;

 const int maxn = ;<br />
 const int maxm = ;<br />
 const int oo = &lt;&lt;;<br />
 struct node{<br />
     int u;<br />
     int v;<br />
     int w;<br />
     int next;<br />
 }edge[maxm];<br />
 int head[maxn];<br />
 int dis[maxn];<br />
 int cnt;<br />
 int n, m;

 void add(int u, int v, int w){<br />
     edge[cnt].u = u;<br />
     edge[cnt].v = v;<br />
     edge[cnt].w = w;<br />
     edge[cnt].next = head[u];<br />
     head[u] = cnt++;<br />
 }

 void dijkstra(int s){<br />
     bool vis[maxn];<br />
     for(int i = ; i &lt; n; i++){<br />
         dis[i] = oo;<br />
         vis[i] = false;<br />
     }<br />
     dis[s] = ;<br />
     for(int i = ; i &lt; n; i++){<br />
         int minn = oo;<br />
         int u = s;<br />
         for(int j = ; j &lt; n; j++){<br />
             if(!vis[j] &amp;&amp; minn &gt; dis[j]){<br />
                 minn = dis[j];<br />
                 u = j;<br />
             }<br />
         }<br />
         for(int j = head[u]; j != -; j = edge[j].next){<br />
             int v = edge[j].v;<br />
             int newdis = minn + edge[j].w;<br />
             if(!vis[v] &amp;&amp; newdis &lt; dis[v]) dis[v] = newdis;<br />
         }<br />
         vis[u] = true;<br />
     }<br />
 }

 void init(){<br />
     cnt = ;<br />
     memset(head, -, sizeof(head));<br />
 }

 int main(){<br />
     while(~scanf("%d %d", &amp;n, &amp;m)){<br />
         int u, v, w;<br />
         init();<br />
         for(int i = ; i &lt; m; i++){<br />
             scanf("%d %d %d", &amp;u, &amp;v, &amp;w);<br />
             add(u, v, w);<br />
             add(v, u, w);<br />
         }<br />
         scanf("%d %d", &amp;u, &amp;v);<br />
         dijkstra(u);<br />
         if(dis[v] &lt; oo) printf("%d\n", dis[v]);<br />
         else puts("-1");<br />
     }<br />
     return ;<br />
 }</pre>
</div></div>
<p>这个代码是杭电1784的代码</p>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnj57g8.html">JS学习进阶中 come on&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/3900e649.html">&lbrack;Tools&rsqb; 远程登录surface字体过大解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq17o4zq.html">Android NDK构建资料</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx04zzq.html">Qt与VS2005&sol;2008的完美配合（自己编译Qt4&period;5&period;1的详细步骤）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vrkg38.html">&lbrack;物理学与PDEs&rsqb;书中的错误指出</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm1ooe9.html">Servlet小试</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmxkp49.html">iOS调试程序时，启动应用失败的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydlv1xq.html">swift入门-day01-基本语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m7p0n8.html">os&period;path&period;exists&lpar;path&rpar; 和 os&period;path&period;lexists&lpar;path&rpar; 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg5w3m8.html">wcf实例模型（随记）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpzzo0q.html">学习笔记：javascript内置对象：数学对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/950lyme8.html">Tomcat性能优化及JVM内存工作原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoweynq.html">C&plus;&plus; WMI获取系统硬件信息&lpar;CPU&sol;DISK&sol;NetWork etc&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljgmz09.html">Jmeter-常用线程组设置及场景运行时间计算</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1zvo09.html">通过微信公众号API复制公众号自定义菜单同时增加子菜单方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyvwedq.html">剑指offer：1&period;找出数组中重复的数（java版）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rvv658.html">山东理工大学SDUT - ACM OJ 题： Python代码 及分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1epol9.html">rpm和yum</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rpn548.html">&lbrack;译&rsqb;Use Dependency Injection In WebForms Application</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2wep08.html">蓝桥杯之剪格子（经典dfs）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxnevzz8.html">Speeding up AngularJS apps with simple optimizations</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdeo7479.html">工作案件1 一切都是有check引起的</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv06m1q.html">前端工程搭建NodeJs&plus;gulp&plus;bower</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ynrejq.html">sublime3 注册码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdeomoz9.html">版本控制器 （Svn，Git）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydre72q.html">Oracle利用数据泵迁移用户</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1ym1j8.html">如何重建Octopress本地环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xvo609.html">asp&period;net 生成PDF方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xwxre8.html">插值和空间分析（一）&lowbar;探索性数据分析（R语言）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xvxnz9.html">Oracle中的日期</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
